CFPRIME DTEB                                                            DTEB        1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
      SUBROUTINE DTEB(H)                                                DTEB        3
CD                                                                      DTEB        4
CD    TO CALCULATE THE DERIVATIVES OF THE STATES OF TANSIENT EXCITATION DTEB        5
CD    BOOSTER, USED BY BOTH RUNGE-KUTTA AND TRAPEZOIDAL METHOD.         DTEB        6
CD                                                                      DTEB        7
CD    THE DATA STRUCTURE OF THIS TYPE OF TRANSIENT EXCITATION BOOSTER   DTEB        8
CD    IS GIVEN BELOW.                                                   DTEB        9
CD                                                                      DTEB       10
CD   6.1 Transient excitation booster type 1                            DTEB       11
CD                                                                      DTEB       12
CD     Booster data                                                     DTEB       13
CD                                                                      DTEB       14
CD     DDAT(JTB+ 1)   = (reserved for future use)                       DTEB       15
CD     DDAT(JTB+ 2)   = K                                               DTEB       16
CD     DDAT(JTB+ 3)   = T1                                              DTEB       17
CD     DDAT(JTB+ 4)   = T2                                              DTEB       18
CD     DDAT(JTB+ 5)   = VTHR                                            DTEB       19
CD                                                                      DTEB       20
CD     Booster states                                                   DTEB       21
CD                                                                      DTEB       22
CD     There are no state variables for transient excitation booster    DTEB       23
CD                                                                      DTEB       24
CD     Booster Y-variables                                              DTEB       25
CD                                                                      DTEB       26
CD     TEB(JYTB+1)    = output of transient excitation booster          DTEB       27
CD                                                                      DTEB       28
      INCLUDE 'PARX.INS'                                                DTEB       29
      INCLUDE 'CNMDAT.INS'                                              DTEB       30
      INCLUDE 'CNEXC.INS'                                               DTEB       31
      INCLUDE 'CNYVAR.INS'                                              DTEB       32
      INCLUDE 'CNUNIT.INS'                                              DTEB       33
      INCLUDE 'CNB4.INS'                                                DTEB       34
C                                                                       DTEB       35
      IF (DDAT(JTB+1).LT.0.0) GOTO 100                                  DTEB       36
      TIMB=TS+H                                                         DTEB       37
      IF (TIMB.LT.DDAT(JTB+1)) GOTO 100                                 DTEB       38
      TIMB=TIMB-DDAT(JTB+1)                                             DTEB       39
      STEB=DDAT(JTB+6)*(EXP(-TIMB/DDAT(JTB+3))-EXP(-TIMB/DDAT(JTB+4)))  DTEB       40
      IF (ET.GT.DDAT(JTB+5)) THEN                                       DTEB       41
         IF (IDDAT(JTB+7).EQ.0) DDAT(JTB+7)=STEB                        DTEB       42
      ELSE                                                              DTEB       43
         IF (IDDAT(JTB+7).EQ.0.OR.STEB.LE.DDAT(JTB+7)) TEB(JYTB+1)=STEB DTEB       44
      ENDIF                                                             DTEB       45
 100  CONTINUE                                                          DTEB       46
C                                                                       DTEB       47
      RETURN                                                            DTEB       48
      END                                                               DTEB       49
